%% Font sizes
lineWidthSmall = 1;
lineWidthBig = 2;
fontSizeSmall = 14;
fontSizeBig = 20;

times = time.get_time_array();
end_time = time.get_time(t);
fig=figure();

%%

plot(database.obstacleSafetyDistance*ones(1,length(times)), '--')
hold on;
distPlot = plot(times(2:end), shortest_agent_dist_plot(2:end) + database.obstacleSafetyDistance); 
set(distPlot,'LineWidth', lineWidthSmall);
legend('Safety Distance', 'Minimum dist between agents each timestep')



%%

hx = xlabel('Time [s]');
set(hx,'FontSize',fontSizeSmall,'FontName','Times');
hy = ylabel('Distance [m]');
set(hy,'FontSize',fontSizeSmall,'FontName','Times');

axis([0 end_time 0 14]);