%% Font sizes
lineWidthSmall = 1;
lineWidthBig = 2;
fontSizeSmall = 14;
fontSizeBig = 20;

times = time.get_time_array();
end_time = time.get_time(t);
fig=figure();

%%

plot(database.obstacleSafetyDistance*ones(1,length(times)), '--')
hold on;
for aa = 1:length(agent_list)
    distPlot = plot(times(2:end), dist_to_obst_plot(aa,2:end) + database.obstacleSafetyDistance);
    hold on;
end
set(distPlot,'LineWidth', lineWidthSmall);
legend('Safety Distance', 'Agent 1', 'Agent 2', 'Agent 3', 'Agent 4', 'Agent 5', 'Agent 6', ...
    'Agent 7', 'Agent 8', 'Agent 9', 'Agent 10', 'Agent 11','Agent 12','Agent 13', 'Agent 14')



%%

hx = xlabel('Time [s]');
set(hx,'FontSize',fontSizeSmall,'FontName','Times');
hy = ylabel('Distance [m]');
set(hy,'FontSize',fontSizeSmall,'FontName','Times');

axis([0 end_time 0 30]);