% subplotSim
%
% Plots a single instant from the simulation, for use in subplot.

t = find(time.get_time_array() == current_time);
%color = ['m', 'c'];

% Plot agents
for kk = 1:length(agent_list)
    agent_list(kk).plot_agent(t, fig, lineWidthSmall, lineWidthBig, database.obstacleSafetyDistance, ['r', 'w']);
    hold on
    
    
    % Plot sensor disk
    %disk_center = agent_list(kk).get_sensor_disk_center(database.obstacleSenseDistance, t);
    %ang=0:0.01:2*pi;
    %r = database.obstacleSenseDistance/2;
    %x_disk = r *cos(ang) + disk_center(1);
    %y_disk = r *sin(ang) + disk_center(2);
    %hSenseDisk = plot(y_disk, x_disk, 'Color', [.17 .17 .17], 'LineStyle', ':');
    %set(hSenseDisk,'LineWidth', lineWidthSmall);
    
    % Plot trajectory
    %hTrajectory = plot(agent_list(kk).state(2,start_index:current_index), agent_list(kk).state(1,start_index:current_index),'-');
    %set(hTrajectory,'LineWidth', lineWidthSmall); hold on;
    
%     target = agent_list(kk).get_target();
%     Plot target
%     hTarget = plot(target(2),target(1),'x');
%     set(hTarget,'LineWidth', 1, 'Color', color(kk));
end

for ii = 1:length(obstacle_list)
    obstacle_list(ii).plot_agent(t, fig, lineWidthSmall, lineWidthBig, database.obstacleSafetyDistance, ['b', 'w']);
    hold on
end

% % Plot target
% hTarget = plot(target(2),target(1),'x', 'Color', 'g');
% set(hTarget,'LineWidth', 1);

%Plot obstacles
%for ii = 1:length(obstacle_list)
% obstacle_list(ii).plot_obstacle(current_index, fig, lineWidthSmall, lineWidthBig, database.obstacleSafetyDistance);
%end

title(['time = ', num2str(current_time), ' s']);
hx = xlabel('y [m]');
set(hx,'FontSize',fontSizeSmall,'FontName','Times');
hy = ylabel('x [m]');
set(hy,'FontSize',fontSizeSmall,'FontName','Times');

axis(axis_array);
