function [psi,V] = RVO_guidance(agent, t)
    
    target = agent.get_target();
    pos = agent.state(1:2,t);
    psi = vector_ang(pos, target);
    
    speed = agent.get_max_speed();
    V = [speed*cos(psi); speed*sin(psi)];

end