function obstacle_list = circle_obstacles(init_list, d_safe, t)
% init_list is structured like this:
% (x, y, psi, x_dot, y_dot, psi_dot, radius, speed, max_yaw_rate)
% where state = [x, y, psi]

len = size(init_list,1);
obstacle_list = [];

for i = 1:len
    obst = static_obstacle(t, init_list(i,7), init_list(i,8), init_list(i,9), d_safe);
    obst.set_initial_conditions([init_list(i,1), init_list(i,2), init_list(i,3)], ...
        [init_list(i,4), init_list(i,5), init_list(i,6)])
    obstacle_list = [ obstacle_list; obst ];
end

end