% agents = [ target_x, target_y, radius, d_safe, max_surge_speed, max_yaw_rate]
radius = 1;
d_safe = database.obstacleSafetyDistance;
m_yaw = 1;
m_speed = 3;
obstacle_list = [];

%%%
%% Scenario 00, basic one obstacle test
%%%
% axis_array = [0 30 0 30];
% plot_end_times = [3 6 9 14];
% 
% param_agents = [
%     15, 25, radius, d_safe, m_speed, m_yaw;
%     15, 5, radius, d_safe, m_speed, m_yaw;
%     20, 20, radius, d_safe, m_speed, m_yaw;
%     %30, 15, radius, d_safe, m_speed, m_yaw;
% ];
% init_list_agents = [ 
%     [15, 5, pi/2, 0], [0, 0, 0, 0];
%     [14, 25, -pi/2, 0], [0, 0, 0, 0];
%     [5, 5, 0, 0], [0, 0, 0, 0];
%     %[-10, 15, 0, 0], [0, 0, 0, 0];
% ];
% agent_list = generate_agents(param_agents, init_list_agents, time);
%%%
%% Scenario 0, used to test cases from Monte Carlo
%%%
%axis_array = [-10 60 -10 60];
% axis_array = [-5 55 -5 55];
% plot_end_times = [3 6 8 11];
% 
% param_agents = [
%     39, 34, radius, d_safe, m_speed, m_yaw;
%     43, 44, radius, d_safe, m_speed, m_yaw;
%     33, 14, radius, d_safe, m_speed, m_yaw;
%     31, 26, radius, d_safe, m_speed, m_yaw;
%     23, 32, radius, d_safe, m_speed, m_yaw;
%     25, 26, radius, d_safe, m_speed, m_yaw;
%     16, 47, radius, d_safe, m_speed, m_yaw;
%     31, 44, radius, d_safe, m_speed, m_yaw;
%     31, 44, radius, d_safe, m_speed, m_yaw;
%     31, 44, radius, d_safe, m_speed, m_yaw;
% ];

% Failed with both new and old speed_adj, parallel agents, "over comp"
% PASSED NOW 
% txx = [5 31 44 17 15 35 45 47 50 11];
% tyy = [2 15 14 21 12 1 1 26 41 30];
% param_agents(:,1) = txx';
% param_agents(:,2) = tyy';
% init_list_agents = [28 5 5.35156986286907 0 0 0 0 0;43 14 5.54215729240380 0 0 0 0 0;39 30 0.817976133495396 0 0 0 0 0;30 32 2.83070030713897 0 0 0 0 0;7 38 4.22895680135922 0 0 0 0 0;6 4 3.26658667896318 0 0 0 0 0;33 39 0.579892985154887 0 0 0 0 0;0 36 1.94231296082693 0 0 0 0 0;6 46 3.65460077282659 0 0 0 0 0;0 17 2.73554029679688 0 0 0 0 0];


%%% RVO testing

% txx = [33 16 18 13 47 24 32 24 14 38];
% tyy = [7 28 3 5 40 5 40 30 44 16];
% param_agents(:,1) = txx';
% param_agents(:,2) = tyy';
% init_list_agents = [13 26 2.58554640487118 0 0 0 0 0;6 27 2.34844794629733 0 0 0 0 0;9 37 5.77318118365092 0 0 0 0 0;24 28 4.32800631651862 0 0 0 0 0;49 24 2.05430449740945 0 0 0 0 0;33 19 5.74700617306468 0 0 0 0 0;15 50 2.72541416463011 0 0 0 0 0;6 16 5.29309352874104 0 0 0 0 0;19 13 5.28557959744343 0 0 0 0 0;28 20 0.835352210413191 0 0 0 0 0];

% txx = ;
% tyy = ;
% param_agents(:,1) = txx';
% param_agents(:,2) = tyy';
% init_list_agents = ;

% txx = ;
% tyy = ;
% param_agents(:,1) = txx';
% param_agents(:,2) = tyy';
% init_list_agents = ;

%agent_list = generate_agents(param_agents, init_list_agents, time);
%%%
%% Scenario 1, Circle experiment 
%%%
% axis_array = [-50 50 -50 50];
% %plot_end_times = [5 12 30 45]; % Used in the thesis
% plot_end_times = [1 5 10 20 35 50];
% 
% num_agents = 40;
% rr = 40;
% ang=0:0.000001:2*pi;
% ix = rr*cos(ang);
% iy = rr*sin(ang);
% ttx = rr*cos(ang+pi);
% tty = rr*sin(ang+pi);
% ang_space = floor(length(ang)/(num_agents));
% 
% param_agents = [];
% init_list_agents = [];
% for kk = 1:num_agents
%     %M regne ut start heading basert p hvilken kvadrant
%     ang = atan2(iy(kk*ang_space), ix(kk*ang_space));
%     param_agents = [ param_agents; ix(kk*ang_space), iy(kk*ang_space), radius, d_safe, m_speed, m_yaw];
%     init_list_agents = [init_list_agents; [ttx(kk*ang_space), tty(kk*ang_space), ang, 0], [0, 0, 0, 0]];
% end
% 
% agent_list = generate_agents(param_agents, init_list_agents, time);

%%%
%% Scenario 2, Two rows of agents meeting
%%%
% axis_array = [-30 30 0 60];
% plot_end_times = [3 6 9 12];
% 
% param_agents = [
%     10, -15, radius, d_safe, m_speed, m_yaw;
%     10, -8, radius, d_safe, m_speed, m_yaw;
%     10, -1, radius, d_safe, m_speed, m_yaw;
%     10, 6, radius, d_safe, m_speed, m_yaw;
%     10, 13, radius, d_safe, m_speed, m_yaw;
%     10, 20, radius, d_safe, m_speed, m_yaw;
%     50, -15, radius, d_safe, m_speed, m_yaw;
%     50, -8, radius, d_safe, m_speed, m_yaw;
%     50, -1, radius, d_safe, m_speed, m_yaw;
%     50, 6, radius, d_safe, m_speed, m_yaw;
%     50, 13, radius, d_safe, m_speed, m_yaw;
%     50, 20, radius, d_safe, m_speed, m_yaw;
% ];
% 
% init_list_agents = [ 
%     [50, -15, pi, 0], [0, 0, 0, 0];
%     [50, -8, pi, 0], [0, 0, 0, 0];
%     [50, -1, pi, 0], [0, 0, 0, 0];
%     [50, 6, pi, 0], [0, 0, 0, 0];
%     [50, 13, pi, 0], [0, 0, 0, 0];
%     [50, 20, pi, 0], [0, 0, 0, 0];
%     [10, -15, 0, 0], [0, 0, 0, 0];
%     [10, -8, 0, 0], [0, 0, 0, 0];
%     [10, -1, 0, 0], [0, 0, 0, 0];
%     [10, 6, 0, 0], [0, 0, 0, 0];
%     [10, 13, 0, 0], [0, 0, 0, 0];
%     [10, 20, 0, 0], [0, 0, 0, 0];
% ];
% agent_list = generate_agents(param_agents, init_list_agents, time);

%%%
%% Scenario 3 - Two agents head on collision
%%%
% axis_array = [0 20 0 20];
% plot_end_times = [3 6 9 14];
% 
% param_agents = [
%     10, 15, radius, d_safe, m_speed, m_yaw;
%     10, 5, radius, d_safe, m_speed, m_yaw;
% ];
% init_list_agents = [ 
%     [10, 5, pi/2, 0], [0, 0, 0, 0];
%     [10, 15, -pi/2, 0], [0, 0, 0, 0];
% ];
% agent_list = generate_agents(param_agents, init_list_agents, time);
 

%%%
%% Scenario 4 - Two agents parallel start, opposite goal
%%%
% axis_array = [-25 25 0 50];
% plot_end_times = [10 15 24 32];
% 
% param_agents = [
%     30, 2, radius, d_safe, m_speed, m_yaw;
%     30, -2, radius, d_safe, m_speed, m_yaw;
% ];
% 
% init_list_agents = [ 
%     [0, -2, 0, 0], [0, 0, 0, 0];
%     [0, 2, 0, 0], [0, 0, 0, 0];
% ];
% agent_list = generate_agents(param_agents, init_list_agents, time);

%%%
%% Scenario 5 - RVO collision
%%%
% axis_array = [-15 15 0 30];
% plot_end_times = [1 2 4 10];
% 
% param_agents = [
%     5, 3, radius, d_safe, m_speed, m_yaw;
%     5, 0, radius, d_safe, m_speed, m_yaw;
%     5, -3, radius, d_safe, m_speed, m_yaw;
%     25, 2, radius, d_safe, m_speed, m_yaw;
%     25, -2, radius, d_safe, m_speed, m_yaw;
% ];
% init_list_agents = [ 
%     [20, 3, pi, 0], [0, 0, 0, 0];
%     [20, 0, pi, 0], [0, 0, 0, 0];
%     [20, -3, pi, 0], [0, 0, 0, 0];
%     [5, 2, 0, 0], [0, 0, 0, 0];
%     [5, -2, 0, 0], [0, 0, 0, 0];
% ];
% agent_list = generate_agents(param_agents, init_list_agents, time);

%% Scenario 6 - Laaaarge square sim
%%%
% 
numA = 25;
area = 200;
s = area/numA;

axis_array = [ 0 area+20 0 area+20];
plot_end_times = [1 20 30 45 60 70];

param_agents = [];
init_list_agents = [];

for iii = 4:numA-2
    param_agents = [param_agents; 
                    area, iii*s, radius, d_safe, m_speed, m_yaw;
                    20, iii*s, radius, d_safe, m_speed, m_yaw;
                    iii*s, area, radius, d_safe, m_speed, m_yaw;
                    iii*s, 20, radius, d_safe, m_speed, m_yaw;
                    area+10, iii*s, radius, d_safe, m_speed, m_yaw;
                    10, iii*s, radius, d_safe, m_speed, m_yaw;
                    iii*s, area+10, radius, d_safe, m_speed, m_yaw;
                    iii*s, 10, radius, d_safe, m_speed, m_yaw
                    ];
                
    init_list_agents = [init_list_agents;
                    [20, iii*s, 0, 0], [0, 0, 0, 0];
                    [area, iii*s, pi, 0], [0, 0, 0, 0];
                    [iii*s, 20, pi/2, 0], [0, 0, 0, 0];
                    [iii*s, area, -pi/2, 0], [0, 0, 0, 0];
                    [10, iii*s, 0, 0], [0, 0, 0, 0];
                    [area+10, iii*s, pi, 0], [0, 0, 0, 0];
                    [iii*s, 10, pi/2, 0], [0, 0, 0, 0];
                    [iii*s, area+10, -pi/2, 0], [0, 0, 0, 0]
                    ];
end

agent_list = generate_agents(param_agents, init_list_agents, time);

%% Scenario 7 - Laaaarge two rows sim
%%%

% numA = 35;
% area = 300;
% s = area/numA;
% 
% axis_array = [ 0 area+20 0 area+20];
% plot_end_times = [1 20 30 50];
% 
% param_agents = [];
% init_list_agents = [];
% 
% for iii = 1:numA
%     param_agents = [param_agents; 
%                     iii*s, 60, radius, d_safe, m_speed, m_yaw;
%                     iii*s+5, 68, radius, d_safe, m_speed, m_yaw;
%                     iii*s, 76, radius, d_safe, m_speed, m_yaw;
%                     iii*s, area-56, radius, d_safe, m_speed, m_yaw;
%                     iii*s+5, area-48, radius, d_safe, m_speed, m_yaw;
%                     iii*s, area-40, radius, d_safe, m_speed, m_yaw;
%                     ];
%                 
%     init_list_agents = [init_list_agents;
%                     [iii*s, area-56, -pi/2, 0], [0, 0, 0, 0];
%                     [iii*s+5, area-48, -pi/2, 0], [0, 0, 0, 0];
%                     [iii*s, area-40, -pi/2, 0], [0, 0, 0, 0];
%                     [iii*s, 60, pi/2, 0], [0, 0, 0, 0];
%                     [iii*s+5, 68, pi/2, 0], [0, 0, 0, 0];
%                     [iii*s, 76, pi/2, 0], [0, 0, 0, 0];
%                     ];
% end
% 
% agent_list = generate_agents(param_agents, init_list_agents, time);
