classdef sim_time < handle
    %UNTITLED3 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (Access = private)        
        start = 0;
        stop = 1;
        step = 1;
        time_array;
    end
    
    methods
        function obj = sim_time(start, stop, step)
            if(nargin>0)
                obj.start=start;
                obj.stop = stop;
                obj.step = step;
            end
            obj.time_array = start:step:stop;
        end
        
        function time_array = get_time_array(obj)
            time_array = obj.time_array;
        end
        
        function sample_count = get_sample_count(obj)
            sample_count = length(obj.time_array);
        end
        
        function time_step = get_time_step(obj)
            time_step  = obj.step;
        end
        
        function time_instant = get_time(obj,t)
            time_instant = obj.time_array(t);
        end
    end
    
end

