function overlap = resolve_overlapping_pos(x, y, d)
% x and y are lists of x and y positions
% d is minimum allowable distance between each point 
% overlap is a bool indicating pos overlap
overlap = false;
for i = 1:length(x)
    for j = 1:length(x)
        if i~=j 
            dist = sqrt((x(i)-x(j))^2 + (y(i)-y(j))^2);
            if dist < d
                overlap = true;
                return;
            end
        end
    end
end
end